//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  DeepSkyBlue
#property indicator_color4  PaleVioletRed
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern int    AibPeriod          = 6;
extern double AibPower           = 0.75;
extern double AibThresholdHigh   = 0.50;
extern double AibThresholdLow    = 1.05;

double aibh[];
double aibl[];
double sigb[];
double sigs[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,aibh);
   SetIndexBuffer(1,aibl);
   SetIndexBuffer(2,sigb); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,sigs); SetIndexStyle(3,DRAW_HISTOGRAM);
      SetLevelValue(0,AibThresholdHigh);
      SetLevelValue(1,AibThresholdLow);
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][2];
#define _nhr 0
#define _nlr 1

int start()
{
   int i,r,count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //
    
      for(i = limit, r= Bars-i-1; i >= 0; i--, r++)
      {
         double atr  = iATR(NULL,0,AibPeriod,i);
         double hrt  = High[i]-Low[i+AibPeriod];
         double lrt  = Low[i]-High[i+AibPeriod];
         if (atr==0) continue;
         
            //
            //
            //
            //
            //
            
            work[r][_nhr] = (hrt/MathPow(AibPeriod,AibPower))/atr;
            work[r][_nlr] = (lrt/MathPow(AibPeriod,AibPower))/atr;
            double nhrMax = work[r][_nhr];
            double nlrMax = work[r][_nlr];
               for (int k=1; k<AibPeriod; k++)
               {
                  nhrMax = MathMax(nhrMax,work[r-k][_nhr]);
                  nlrMax = MathMax(nlrMax,work[r-k][_nlr]);
               }
            aibh[i] = nhrMax;
            aibl[i] = nlrMax;
            
            //
            //
            //
            //
            //

            sigb[i] = EMPTY_VALUE;
            sigs[i] = EMPTY_VALUE;
               if (nhrMax>AibThresholdHigh && nlrMax < AibThresholdLow)  sigb[i] = MathMax(AibThresholdHigh,AibThresholdLow);
               if (nlrMax>AibThresholdLow  && nhrMax < AibThresholdHigh) sigs[i] = MathMax(AibThresholdHigh,AibThresholdLow);
      }
   return(0);
}